(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('artesgo-foundation', ['exports', '@angular/common', '@angular/core'], factory) :
    (factory((global['artesgo-foundation'] = {}),global.ng.common,global.ng.core));
}(this, (function (exports,common,core) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GridComponent = /** @class */ (function () {
        function GridComponent() {
            this.rowSizes = [];
            this.columnSizes = [];
            this.style = {};
        }
        Object.defineProperty(GridComponent.prototype, "rows", {
            set: /**
             * @param {?} val
             * @return {?}
             */ function (val) {
                this._rows = val;
                /** @type {?} */
                var rows = "";
                for (var i = 0; i < val; i++) {
                    rows = rows + " " + this.getSize(this.rowSizes, i);
                }
                rows = rows.trim();
                this.style = __assign({}, this.style, { 'grid-template-rows': rows });
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GridComponent.prototype, "cols", {
            set: /**
             * @param {?} val
             * @return {?}
             */ function (val) {
                this._cols = val;
                /** @type {?} */
                var cols = "";
                for (var i = 0; i < val; i++) {
                    cols = cols + " " + this.getSize(this.columnSizes, i);
                }
                cols = cols.trim();
                this.style = __assign({}, this.style, { 'grid-template-columns': cols });
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        GridComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} arr
         * @param {?} col
         * @return {?}
         */
        GridComponent.prototype.getSize = /**
         * @param {?} arr
         * @param {?} col
         * @return {?}
         */
            function (arr, col) {
                return "" + (arr[col].value || 1) + arr[col].unit;
            };
        GridComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'fdn-grid',
                        template: "<div class=\"grid\" [ngStyle]=\"style\">\n  <ng-content></ng-content>\n</div>",
                        styles: [":host{display:block}.grid{display:grid;display:-ms-grid}"]
                    }] }
        ];
        /** @nocollapse */
        GridComponent.ctorParameters = function () { return []; };
        GridComponent.propDecorators = {
            rowSizes: [{ type: core.Input }],
            columnSizes: [{ type: core.Input }],
            rows: [{ type: core.Input }],
            cols: [{ type: core.Input }]
        };
        return GridComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GridItemDirective = /** @class */ (function () {
        function GridItemDirective(el) {
            this.el = el;
        }
        Object.defineProperty(GridItemDirective.prototype, "row", {
            set: /**
             * @param {?} val
             * @return {?}
             */ function (val) {
                this._row = val;
                this.el.nativeElement.style.gridRow = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GridItemDirective.prototype, "col", {
            set: /**
             * @param {?} val
             * @return {?}
             */ function (val) {
                this._col = val;
                this.el.nativeElement.style.gridColumn = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GridItemDirective.prototype, "rowSpan", {
            set: /**
             * @param {?} val
             * @return {?}
             */ function (val) {
                this._rowSpan = val;
                this.el.nativeElement.style.gridRowEnd = this._row + val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GridItemDirective.prototype, "colSpan", {
            set: /**
             * @param {?} val
             * @return {?}
             */ function (val) {
                this._colSpan = val;
                this.el.nativeElement.style.gridColumnEnd = this._col + val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GridItemDirective.prototype, "debug", {
            set: /**
             * @param {?} debug
             * @return {?}
             */ function (debug) {
                if (debug) {
                    this.el.nativeElement.style.border = '1px solid black';
                    this.el.nativeElement.style.backgroundColor = this.randomRGB();
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        GridItemDirective.prototype.random = /**
         * @return {?}
         */
            function () {
                return Math.floor(Math.random() * 128) + 127;
            };
        /**
         * @return {?}
         */
        GridItemDirective.prototype.randomRGB = /**
         * @return {?}
         */
            function () {
                return "rgba(" + this.random() + ", " + this.random() + ", " + this.random() + ", 1)";
            };
        GridItemDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[fdn-grid-item]'
                    },] }
        ];
        /** @nocollapse */
        GridItemDirective.ctorParameters = function () {
            return [
                { type: core.ElementRef }
            ];
        };
        GridItemDirective.propDecorators = {
            row: [{ type: core.Input }],
            col: [{ type: core.Input }],
            rowSpan: [{ type: core.Input }],
            colSpan: [{ type: core.Input }],
            debug: [{ type: core.Input }]
        };
        return GridItemDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var EXPORTED = [
        GridComponent,
        GridItemDirective
    ];
    var FoundationModule = /** @class */ (function () {
        function FoundationModule() {
        }
        FoundationModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: EXPORTED,
                        exports: EXPORTED
                    },] }
        ];
        return FoundationModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.FoundationModule = FoundationModule;
    exports.ɵb = GridItemDirective;
    exports.ɵa = GridComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=artesgo-foundation.umd.js.map