import { CommonModule } from '@angular/common';
import { Component, Input, Directive, ElementRef, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GridComponent {
    constructor() {
        this.rowSizes = [];
        this.columnSizes = [];
        this.style = {};
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set rows(val) {
        this._rows = val;
        /** @type {?} */
        let rows = ``;
        for (let i = 0; i < val; i++) {
            rows = `${rows} ${this.getSize(this.rowSizes, i)}`;
        }
        rows = rows.trim();
        this.style = Object.assign({}, this.style, { 'grid-template-rows': rows });
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set cols(val) {
        this._cols = val;
        /** @type {?} */
        let cols = ``;
        for (let i = 0; i < val; i++) {
            cols = `${cols} ${this.getSize(this.columnSizes, i)}`;
        }
        cols = cols.trim();
        this.style = Object.assign({}, this.style, { 'grid-template-columns': cols });
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} arr
     * @param {?} col
     * @return {?}
     */
    getSize(arr, col) {
        return `${arr[col].value || 1}${arr[col].unit}`;
    }
}
GridComponent.decorators = [
    { type: Component, args: [{
                selector: 'fdn-grid',
                template: "<div class=\"grid\" [ngStyle]=\"style\">\n  <ng-content></ng-content>\n</div>",
                styles: [":host{display:block}.grid{display:grid;display:-ms-grid}"]
            }] }
];
/** @nocollapse */
GridComponent.ctorParameters = () => [];
GridComponent.propDecorators = {
    rowSizes: [{ type: Input }],
    columnSizes: [{ type: Input }],
    rows: [{ type: Input }],
    cols: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class GridItemDirective {
    /**
     * @param {?} el
     */
    constructor(el) {
        this.el = el;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set row(val) {
        this._row = val;
        this.el.nativeElement.style.gridRow = val;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set col(val) {
        this._col = val;
        this.el.nativeElement.style.gridColumn = val;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set rowSpan(val) {
        this._rowSpan = val;
        this.el.nativeElement.style.gridRowEnd = this._row + val;
    }
    /**
     * @param {?} val
     * @return {?}
     */
    set colSpan(val) {
        this._colSpan = val;
        this.el.nativeElement.style.gridColumnEnd = this._col + val;
    }
    /**
     * @param {?} debug
     * @return {?}
     */
    set debug(debug) {
        if (debug) {
            this.el.nativeElement.style.border = '1px solid black';
            this.el.nativeElement.style.backgroundColor = this.randomRGB();
        }
    }
    ;
    /**
     * @return {?}
     */
    random() {
        return Math.floor(Math.random() * 128) + 127;
    }
    /**
     * @return {?}
     */
    randomRGB() {
        return `rgba(${this.random()}, ${this.random()}, ${this.random()}, 1)`;
    }
}
GridItemDirective.decorators = [
    { type: Directive, args: [{
                selector: '[fdn-grid-item]'
            },] }
];
/** @nocollapse */
GridItemDirective.ctorParameters = () => [
    { type: ElementRef }
];
GridItemDirective.propDecorators = {
    row: [{ type: Input }],
    col: [{ type: Input }],
    rowSpan: [{ type: Input }],
    colSpan: [{ type: Input }],
    debug: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const EXPORTED = [
    GridComponent,
    GridItemDirective
];
class FoundationModule {
}
FoundationModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: EXPORTED,
                exports: EXPORTED
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FoundationModule, GridItemDirective as ɵb, GridComponent as ɵa };

//# sourceMappingURL=artesgo-foundation.js.map