import { CommonModule } from '@angular/common';
import { __assign } from 'tslib';
import { Component, Input, Directive, ElementRef, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var GridComponent = /** @class */ (function () {
    function GridComponent() {
        this.rowSizes = [];
        this.columnSizes = [];
        this.style = {};
    }
    Object.defineProperty(GridComponent.prototype, "rows", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this._rows = val;
            /** @type {?} */
            var rows = "";
            for (var i = 0; i < val; i++) {
                rows = rows + " " + this.getSize(this.rowSizes, i);
            }
            rows = rows.trim();
            this.style = __assign({}, this.style, { 'grid-template-rows': rows });
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridComponent.prototype, "cols", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this._cols = val;
            /** @type {?} */
            var cols = "";
            for (var i = 0; i < val; i++) {
                cols = cols + " " + this.getSize(this.columnSizes, i);
            }
            cols = cols.trim();
            this.style = __assign({}, this.style, { 'grid-template-columns': cols });
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    GridComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} arr
     * @param {?} col
     * @return {?}
     */
    GridComponent.prototype.getSize = /**
     * @param {?} arr
     * @param {?} col
     * @return {?}
     */
    function (arr, col) {
        return "" + (arr[col].value || 1) + arr[col].unit;
    };
    GridComponent.decorators = [
        { type: Component, args: [{
                    selector: 'fdn-grid',
                    template: "<div class=\"grid\" [ngStyle]=\"style\">\n  <ng-content></ng-content>\n</div>",
                    styles: [":host{display:block}.grid{display:grid;display:-ms-grid}"]
                }] }
    ];
    /** @nocollapse */
    GridComponent.ctorParameters = function () { return []; };
    GridComponent.propDecorators = {
        rowSizes: [{ type: Input }],
        columnSizes: [{ type: Input }],
        rows: [{ type: Input }],
        cols: [{ type: Input }]
    };
    return GridComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var GridItemDirective = /** @class */ (function () {
    function GridItemDirective(el) {
        this.el = el;
    }
    Object.defineProperty(GridItemDirective.prototype, "row", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this._row = val;
            this.el.nativeElement.style.gridRow = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridItemDirective.prototype, "col", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this._col = val;
            this.el.nativeElement.style.gridColumn = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridItemDirective.prototype, "rowSpan", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this._rowSpan = val;
            this.el.nativeElement.style.gridRowEnd = this._row + val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridItemDirective.prototype, "colSpan", {
        set: /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this._colSpan = val;
            this.el.nativeElement.style.gridColumnEnd = this._col + val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GridItemDirective.prototype, "debug", {
        set: /**
         * @param {?} debug
         * @return {?}
         */
        function (debug) {
            if (debug) {
                this.el.nativeElement.style.border = '1px solid black';
                this.el.nativeElement.style.backgroundColor = this.randomRGB();
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    GridItemDirective.prototype.random = /**
     * @return {?}
     */
    function () {
        return Math.floor(Math.random() * 128) + 127;
    };
    /**
     * @return {?}
     */
    GridItemDirective.prototype.randomRGB = /**
     * @return {?}
     */
    function () {
        return "rgba(" + this.random() + ", " + this.random() + ", " + this.random() + ", 1)";
    };
    GridItemDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[fdn-grid-item]'
                },] }
    ];
    /** @nocollapse */
    GridItemDirective.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    GridItemDirective.propDecorators = {
        row: [{ type: Input }],
        col: [{ type: Input }],
        rowSpan: [{ type: Input }],
        colSpan: [{ type: Input }],
        debug: [{ type: Input }]
    };
    return GridItemDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var EXPORTED = [
    GridComponent,
    GridItemDirective
];
var FoundationModule = /** @class */ (function () {
    function FoundationModule() {
    }
    FoundationModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: EXPORTED,
                    exports: EXPORTED
                },] }
    ];
    return FoundationModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FoundationModule, GridItemDirective as ɵb, GridComponent as ɵa };

//# sourceMappingURL=artesgo-foundation.js.map